function D = calculate_gradient(cp,pd,sigma,more_accurate)%, ug)
% gradient is the area of cells, parts inside the given polygon cp

% if need more accurate, cell area will be calculated triangle by triangle,
% otherwise a approximation method will be used
if ~exist('more_accurate','var')
    more_accurate = false;
end

nc = size(pd.cell,1);
D = zeros(nc,1);

in = true(nc,1);
in2 = isinpolygon(cp,pd.dpe);
% in2 = InPolygon(cp(:,1),cp(:,2),pd.dpe(:,1),pd.dpe(:,2));

% find out cells not in cp completely
for i = 1:nc
    ci = pd.cell{i};
    if ~all(in2(ci))
        in(i) = false;
    end
end
% cp(end,:) = [];

for i = 1:nc
    ci = pd.dpe(pd.cell{i},:);
    
    if more_accurate
        if ~in(i)
            pc = polybool([cp(:,1),cp(:,2)],[ci(:,1),ci(:,2)],'and');
            ci = pc{1};
            
%             pc = polybool([cp(:,1),cp(:,2)],[ci(:,1),ci(:,2)],'and',[],[],ug);
%             ci = pc{1};

%             [x,y] = polybool('and',cp(:,1),cp(:,2),ci(:,1),ci(:,2));
%             ci = [x,y];
            
            ci = ci([1:end,1],:);
        end
        
        p0 = mean(ci(1:end-1,:));
        for j = 1:length(ci)-1
            p1 = ci(j,:);
            p2 = ci(j+1,:);
            D(i) = D(i) + face_area([1,2,3],[p0;p1;p2])*sigma(mean([p0;p1;p2]));
        end
    end
    
    if in(i)
        ci = ci(1:end-1,:);
        mui = (2*mean(sigma(ci))+sigma(mean(ci)))/3;
%         D(i) = polyarea({ci})*mui;
%         D(i) = polyarea(ci(:,1),ci(:,2))*mui;
        try
        D(i) = sum(ci(1:end,1).*ci([2:end,1],2) - ci(1:end,2).*ci([2:end,1],1))/2*mui;
        catch
            D(i) = 0;
%             pause;
        end
%         if isnan(D(i))
%             D(i) = 0;
%         end
        
    else % if cell's part outside cp
        try
            pc = polybool([cp(:,1),cp(:,2)],[ci(:,1),ci(:,2)],'and');
            xy = pc{1};
            
%             pc = polybool([cp(:,1),cp(:,2)],[ci(:,1),ci(:,2)],'and',[],[],ug);
%             xy = pc{1};

%             [x,y] = polybool('and',cp(:,1),cp(:,2),ci(:,1),ci(:,2));
%             xy = [x,y];

            mui = (2*mean(sigma(xy))+sigma(mean(xy)))/3;
%             D(i) = polyarea({xy})*mui;
%             D(i) = polyarea(xy(:,1),xy(:,2))*mui;
            D(i) = sum(xy(1:end,1).*xy([2:end,1],2) - xy(1:end,2).*xy([2:end,1],1))/2*mui;
        catch ex
            D(i) = 0;
            warning('occured when computing polygon intersection, most probably this cell went out of prescibed boundary')
        end        
    end
end